<template>
  <div v-if="allowFilePreview" class="doc" style="background:#FFF;">
    <p style="margin:auto; margin-top:250px;" class="text-center">
      Önizleme hazırlanıyor...
      <span v:show="retryCount > 0">({{ retryCount }})</span>
    </p>
    <iframe
      id="iFrame"
      :src="documentUrl"
      class="doc"
      @load="iframeLoad"
    ></iframe>
    <button class="close btn btn-secondary" @click="close">Kapat</button>
  </div>
  <div v-else class="doc" style="background:#FFF;">    
    <p style="margin:auto; margin-top:250px;" class="text-center">
      Dosya indiriliyor...
    </p>
  </div>
</template>
<script>
export default {
  name: "DocumentPreview",
  components: {},
  data() {
    return {
      timer: null,
      retryCount: null
    };
  },
  props: {
    document: null
  },
  methods: {
    close() {
      this.$emit("close");
    },
    isContentLoaded() {
      return this.frameObject.contentWindow.length > 0;
    },
    loadFrame() {
      console.log("Checking iframeLoaded:" + String(this.isContentLoaded()));
      if (!this.isContentLoaded()) {
        this.retryCount++;
        console.log("Retrying... (" + String(this.retryCount) + ")");
        this.frameObject.src = this.documentUrl;
      }
    },
    startInterval() {
      console.log("Interval starting...");
      this.timer = setInterval(this.loadFrame, 3000);
      console.log("Interval started.");
    },
    iframeLoad() {
      if (this.isContentLoaded()) {
        console.log(
          "Load succeed. (Retry Count : " + String(this.retryCount) + ")"
        );
        clearInterval(this.timer);
        console.log("Interval cleared.");
      }
    },
  },
  created() {
    console.log("Entered to function Created.");
    this.retryCount = 0;
  
    if(this.allowFilePreview)
      this.startInterval();
    else
    {
      window.location = this.document.Url;
      this.close();
    }
  },
  beforeDestroy() {
    if (this.timer) {
      clearInterval(this.timer);
      console.log("Interval cleared.");
    }
  },
  computed: {
    allowFilePreview(){
      return window.settings.allowFilePreview ?? false;
    },
    frameObject() {
      return document.getElementById("iFrame");
    },
    documentUrl() {
      if(this.allowFilePreview)
        return (
          "https://docs.google.com/gview?embedded=true&url=" + this.document.Url
        );
      else
        return null;
    }
  }
};
</script>
<style scoped>
.doc {
  z-index: 9999;
  position: fixed;
  top: 0px;
  right: 0;
  bottom: 0;
  left: 0;
  height: 100%;
  width: 100%;
}

.close {
  position: fixed;
  z-index: 99999;
  top: 10px;
  left: 10px;
}
</style>
